var
  MT_STR_Information:string;
  MT_STR_Confirmation:string;
  MT_STR_Warning:string;
  MT_STR_Error:string;

  MB_STR_OK:string;
  MB_STR_Cancel:string;
  MB_STR_Yes:string;
  MB_STR_No:string;

  SCH_NEED_UPD:string;
  MSG_ABOUT:string;
  MSG_GENLOGINFO:string;
  MSG_CREATEFLDR:string;
  MSG_SAVEDRAW:string;
  MSG_DELETEDRAW:string;
  MSG_CANNOTGENERATE:string;
  MSG_FILELOCKED:string;
  MSG_RESETFIXTURES:string;
  MSG_DOCNOTEXISTS:string;
  MSG_REMOVEALLPARTS:string;
  MSG_DELETEDBFILE:string;
  MSG_CLEARFIXTURES:string;
  MSG_UNLOCKSYSSEL:string;

  STR_APPWEB:string;
  STR_UNTITLED:string;
  STR_STATUSPARTSCOUNT:string;
  STR_STATUSMATCHESCOUNT:string;
  STR_ERRORNUMBER:string;

  PG_LOADINGDRAW:string;
  PG_SAVINGDRAW:string;
  PG_GENERATINGDRAW:string;

  FD_PCDFFILTER:string;
  FD_CSVFILTER:string;

  LOG_DOCUMENT:string;

  STR_DRAWPREVIEW:string;
  STR_WELCOMEPAGE:string;
  STR_DRAW:string;
  STR_NEWPARTICIPANT:string;

  MI_EDITFIXTURE_STD:string;

procedure LocalizeStrVar(const AIni:TMemIniFile; var SVar:string; const ID:string; const DefVal:string);
begin
  SVar:=ReplaceStr(AIni.ReadString('constants',ID,DefVal),'\n',#13#10);
end;

function LoadLangFile(AOwner:TObject; const AFileName:string):Boolean;
var
  Ini:TMemIniFile;
  SL:TStringList;
  sec:string;
  i:integer;
begin
  Result := False;
  try
    Ini:=TMemIniFile.Create(AFileName);
    try
      LocalizeStrVar(Ini, MT_STR_Information, 'MT_STR_Information', 'Information');
      LocalizeStrVar(Ini, MT_STR_Confirmation, 'MT_STR_Confirmation', 'Confirmation');
      LocalizeStrVar(Ini, MT_STR_Warning, 'MT_STR_Warning', 'Warning');
      LocalizeStrVar(Ini, MT_STR_Error, 'MT_STR_Error', 'Error');

      LocalizeStrVar(Ini, MB_STR_OK, 'MB_STR_OK', '&OK');
      LocalizeStrVar(Ini, MB_STR_Cancel, 'MB_STR_Cancel', '&Cancel');
      LocalizeStrVar(Ini, MB_STR_Yes, 'MB_STR_Yes', '&Yes');
      LocalizeStrVar(Ini, MB_STR_No, 'MB_STR_No', '&No');

      LocalizeStrVar(Ini, SCH_NEED_UPD, 'SCH_NEED_UPD', 'You have modified the participants list, so you need to reset or clear the draw fixtures!');

      LocalizeStrVar(Ini, MSG_ABOUT, 'MSG_ABOUT', 'Precision Competitions - Draw Designer v%s'#13#10#13#10+
                  'Draws and fixtures designer for tournaments, leagues and other competitions'#13#10#13#10+
                  'Copyright (c) 2008-%d  Precision software & consulting');
      LocalizeStrVar(Ini, MSG_GENLOGINFO, 'MSG_GENLOGINFO', 'Click "%s" to create resulting draw.');
      LocalizeStrVar(Ini, MSG_CREATEFLDR, 'MSG_CREATEFLDR', 'Cannot create folder!'#13#10#13#10'%s');
      LocalizeStrVar(Ini, MSG_SAVEDRAW, 'MSG_SAVEDRAW', 'Do you want to save the current draw?'#13#10#13#10'%s');
      LocalizeStrVar(Ini, MSG_DELETEDRAW, 'MSG_DELETEDRAW', 'Do you really want to delete the selected draw?'#13#10#13#10'%s');
      LocalizeStrVar(Ini, MSG_CANNOTGENERATE, 'MSG_CANNOTGENERATE', 'Cannot generate draw!');
      LocalizeStrVar(Ini, MSG_FILELOCKED, 'MSG_FILELOCKED', 'The resulting file is probably opened in another application.');
      LocalizeStrVar(Ini, MSG_RESETFIXTURES, 'MSG_RESETFIXTURES', 'Do you really want to reset current fixtures?');
      LocalizeStrVar(Ini, MSG_DOCNOTEXISTS, 'MSG_DOCNOTEXISTS', 'Cannot open resulting document!'#13#10'You must export the draw first.');
      LocalizeStrVar(Ini, MSG_REMOVEALLPARTS, 'MSG_REMOVEALLPARTS', 'Do you really want to remove all participants from the list?');
      LocalizeStrVar(Ini, MSG_DELETEDBFILE, 'MSG_DELETEDBFILE', 'Do you really want to delete the selected database file?'#13#10#13#10'%s');
      LocalizeStrVar(Ini, MSG_CLEARFIXTURES, 'MSG_CLEARFIXTURES', 'Do you really want to clear current fixtures?');
      LocalizeStrVar(Ini, MSG_UNLOCKSYSSEL, 'MSG_UNLOCKSYSSEL', 'Do you really want to unlock the playing system modifications for current draw?'#13#10#13#10'You will have to reset or check your current fixtures then.');

      LocalizeStrVar(Ini, STR_APPWEB, 'STR_APPWEB', 'http://www.be-precision.com/draws/');
      LocalizeStrVar(Ini, STR_UNTITLED, 'STR_UNTITLED', 'Untitled');
      LocalizeStrVar(Ini, STR_STATUSPARTSCOUNT, 'STR_STATUSPARTSCOUNT', 'Participants: %d');
      LocalizeStrVar(Ini, STR_STATUSMATCHESCOUNT, 'STR_STATUSMATCHESCOUNT', 'Matches: %d');
      LocalizeStrVar(Ini, STR_ERRORNUMBER, 'STR_ERRORNUMBER', 'Error #%d');

      LocalizeStrVar(Ini, PG_LOADINGDRAW, 'PG_LOADINGDRAW', 'Loading draw ...');
      LocalizeStrVar(Ini, PG_SAVINGDRAW, 'PG_SAVINGDRAW', 'Saving draw ...');
      LocalizeStrVar(Ini, PG_GENERATINGDRAW, 'PG_GENERATINGDRAW', 'Generating draw ...');

      LocalizeStrVar(Ini, FD_PCDFFILTER, 'FD_PCDFFILTER', 'Draw Designer files (*.pcdf)|*.pcdf|All files (*.*)|*.*');
      LocalizeStrVar(Ini, FD_CSVFILTER, 'FD_CSVFILTER', 'Data files (*.csv)|*.csv|All files (*.*)|*.*');

      LocalizeStrVar(Ini, LOG_DOCUMENT, 'LOG_DOCUMENT', 'Resulting document(s):');

      LocalizeStrVar(Ini, STR_DRAWPREVIEW, 'STR_DRAWPREVIEW', 'Draw preview');
      LocalizeStrVar(Ini, STR_WELCOMEPAGE, 'STR_WELCOMEPAGE', 'Welcome page');
      LocalizeStrVar(Ini, STR_DRAW, 'STR_DRAW', '<draw>');
      LocalizeStrVar(Ini, STR_NEWPARTICIPANT, 'STR_NEWPARTICIPANT', 'Participant %s');

      LocalizeStrVar(Ini, MI_EDITFIXTURE_STD, 'MI_EDITFIXTURE_STD', 'Simple');

      if AOwner<>nil then
      begin
        sec:='TPSForm';
        SL:=TStringList.Create;
        try
          Ini.ReadSectionValues(sec,SL);
          i:=SL.IndexOfName('Self.Caption');
          if i>=0 then
          begin
            WritePropertyStr(Self, 'Caption', ReplaceStr(SL.ValueFromIndex[i],'\n',#13#10));
            SL.Delete(i);
          end;
          for i:=0 to SL.Count-1 do
            WritePropertyStr(Self, SL.Names[i], ReplaceStr(SL.ValueFromIndex[i],'\n',#13#10));
        finally
          SL.Free;
        end;
      end;

      Result := True;
    finally
      LocalizeMsgDlgCaption(mtInformation, MT_STR_Information);
      LocalizeMsgDlgCaption(mtConfirmation, MT_STR_Confirmation);
      LocalizeMsgDlgCaption(mtWarning, MT_STR_Warning);
      LocalizeMsgDlgCaption(mtError, MT_STR_Error);

      LocalizeButtonCaption(mbOK, MB_STR_OK);
      LocalizeButtonCaption(mbCancel, MB_STR_Cancel);
      LocalizeButtonCaption(mbYes, MB_STR_Yes);
      LocalizeButtonCaption(mbNo, MB_STR_No);

      Ini.free;
    end;
  except
  end;
end;
