function ProcessDraw:integer;
var
  tmp:string;
  vi1,vi2,vir,vib:integer;
  yy,mm,dd:word;
begin
  Result:=1;
  try

    // read config
    if LoadStrFromFile(tmp,Opt.OptionsFile) then
    begin
      Options.Text:=tmp;
      Opt.DrawParticipantsCount:=StrToIntDef(Options.Values['DrawParticipantsCount'],0);
      Opt.TargetFormat:=StrToTargetFormat(Options.Values['TargetFormat']);
      Opt.DataParticipantsFile:=trim(Options.Values['DataParticipantsFile']);
      Opt.DataScheduleFile:=trim(Options.Values['DataScheduleFile']);
      Opt.PaperSize:=StrToPaperSize(Options.Values['PaperSize']);
      Opt.PageOrientation:=StrToPageOrientation(Options.Values['PageOrientation']);
      Opt.DrawTitle:=Options.Values['DrawTitle'];
      Opt.DrawType:=Options.Values['DrawType'];
      Opt.docKeywords:=Options.Values['DocumentKeywords'];
      Opt.docAuthor:=Options.Values['DocumentAuthor'];
      if Opt.docAuthor='' then Opt.docAuthor:='Precision software & consulting';
      if Opt.DrawTitle='' then
        Opt.docDescription:=Opt.DrawType
      else
        Opt.docDescription:=Opt.DrawTitle;

      docCreator:=Options.Values['DocumentCreator'];
      if docCreator='' then
      begin
        GetFileVerInfoEx(GetVariable('Interpreter'),vi1,vi2,vir,vib);
        docCreator:='Draw Designer '+inttostr(vi1)+'.'+inttostr(vi2);
      end;
      DecodeDate(now,yy,mm,dd);
      docCopyright:='Draw Designer,  '#169' 2008 - '+inttostr(yy)+'  Precision software & consulting,  www.be-precision.com';

      Opt.Margins.Left:=StrToIntDef(Options.Values['PageMarginLeft'],10);
      Opt.Margins.Top:=StrToIntDef(Options.Values['PageMarginTop'],10);
      Opt.Margins.Right:=StrToIntDef(Options.Values['PageMarginRight'],10);
      Opt.Margins.Bottom:=StrToIntDef(Options.Values['PageMarginBottom'],10);

      Opt.DrawFontName := Options.Values['DrawFontName']; if Opt.DrawFontName='' then Opt.DrawFontName:='Arial';
      Opt.DrawFontPercent := StrToIntDef(Options.Values['DrawFontPercent'],100);

      Opt.DataByeInfoText:=Options.Values['DataByeInfoText']; if Opt.DataByeInfoText='' then Opt.DataByeInfoText:='bye';
      Opt.DrawGroupInfoText:=Options.Values['DrawGroupInfoText']; if Opt.DrawGroupInfoText='' then Opt.DrawGroupInfoText:='Group';
      Opt.DrawGroupLabelText:=Options.Values['DrawGroupLabelText']; if Opt.DrawGroupLabelText='' then Opt.DrawGroupLabelText:='Name';
      Opt.DataGroupStats:=Options.Values['DataGroupStats'];

      Opt.DataRandomizeSeeded:=IsOptionChecked(Options.Values['DataRandomizeSeeded'],False);
      Opt.DataRandomizeNonSeeded:=IsOptionChecked(Options.Values['DataRandomizeNonSeeded'],False);

      Opt.DataWinPts:=StrToFloatGeneral(Options.Values['DataWinPts'],3);
      Opt.DataDrawPts:=StrToFloatGeneral(Options.Values['DataDrawPts'],1);
      Opt.DataLostPts:=StrToFloatGeneral(Options.Values['DataLostPts'],0);
      Opt.DataPenaltyPts:=StrToFloatGeneral(Options.Values['DataPenaltyPts'],-1);
      Opt.DataHomeAndAway:=IsOptionChecked(Options.Values['DataHomeAndAway'],False);

      Opt.DrawParticipantsCount:=StrToIntDef(Options.Values['DrawParticipantsCount'],0);
      Opt.Draw3rdPlace := IsOptionChecked(Options.Values['Draw3rdPlace'],False);
      if Opt.Draw3rdPlace and (Opt.DrawParticipantsCount<=3) then Opt.Draw3rdPlace:=False;

      Opt.DrawOtherInfo:=stringReplace(Options.Values['DrawOtherInfo'],'\n',#13#10,[rfReplaceAll]);
      Opt.DrawLineWidth:=StrToIntDef(Options.Values['DrawLineWidth'],1);
      Opt.DrawInfoLineWidth:=StrToIntDef(Options.Values['DrawInfoLineWidth'],1);

      Opt.DrawShowSeed:=IsOptionChecked(Options.Values['DrawShowSeed'],False);
      Opt.DrawSeedChars:=Options.Values['DrawSeedChars'];
      Opt.DrawShowSeedBold:=IsOptionChecked(Options.Values['DrawShowSeedBold'],False);
      Opt.DrawSeededLinesBold:=IsOptionChecked(Options.Values['DrawSeededLinesBold'],False);

      Opt.Adv_Color_InfoBackground:=StrToIntDef(Options.Values['Adv_Color_InfoBackground'],$00D0D0D0);
      Opt.Adv_Color_Line:=StrToIntDef(Options.Values['Adv_Color_Line'],clBlack);
      Opt.Adv_Color_InfoLine:=StrToIntDef(Options.Values['Adv_Color_InfoLine'],clBlack);
      Opt.Adv_Color_Font:=StrToIntDef(Options.Values['Adv_Color_Font'],clBlack);
      Opt.Adv_Color_InfoFont:=StrToIntDef(Options.Values['Adv_Color_InfoFont'],clBlack);
      Opt.Adv_Bool_RoundCorners:=IsOptionChecked(Options.Values['Adv_Bool_RoundCorners'],False);

      if (Length(Opt.TargetFile)=0) or (not ForceDirectories(ExtractFilePath(Opt.TargetFile))) then
        Result:=5 // Cannot create file
      else
      begin
        // read participants
        if length(Opt.DataParticipantsFile)>0 then
        begin
          Opt.DataParticipantsFile:=ExpandFileNameEx(Opt.OptionsFile, Opt.DataParticipantsFile);
          tmp:='';
          if LoadStrFromFile(tmp,Opt.DataParticipantsFile) and (length(tmp)>0) then
          begin
            Players.Text:=tmp;
            if Players.Count>0 then
              Players.Delete(0); // remove header
          end;
        end;

        // read current fixtures
        if length(Opt.DataScheduleFile)>0 then
        begin
          Opt.DataScheduleFile:=ExpandFileNameEx(Opt.OptionsFile, Opt.DataScheduleFile);
          tmp:='';
          if LoadStrFromFile(tmp,Opt.DataScheduleFile) and (length(tmp)>0) then
          begin
            Matches.Text:=tmp;
            if Matches.Count>0 then
              Matches.Delete(0); // remove header
          end;
        end;

        // normalize participants count
        if Players.Count>0 then
          Opt.DrawParticipantsCount:=Players.Count;

        if not GenerateFixtures then
          Result := 4 // Cannot generate fixtures
        else
        begin
          Result:=MakeDraw;
          if (Result=0) and (Rank.Count>0) then
            SaveStrToFileEx(CRankFileFields+#13#10+Rank.Text,ChangeFileExt(Opt.OptionsFile,'.standings.csv'),'utf-8');
        end;
      end;
    end
    else
      Result:=6; // Configuration file cannot be loaded

  except
    ;
  end;
end;

begin
  InitSPPI;
  Options:=TStringList.Create;
  Players:=TStringList.Create;
  Matches:=TStringList.Create;
  Rank:=TStringList.Create;
  DrawDoc:=TStringList.Create;
  try
    Opt.OptionsFile:=ParamStr(1);
    Opt.TargetFile:=ParamStr(2);
    Opt.AlwaysSaveEMF:=ansilowercase(ParamStr(3))='-doemf';
    ExitCode := ProcessDraw;
    CleanUp;
  finally
    DrawDoc.Free;
    Rank.Free;
    Matches.free;
    Players.free;
    Options.Free;
  end;
end.