procedure _OffsetRect(var R:TRect; x:integer; y:integer);
begin
  R.Right:=R.Right+x;
  R.Left:=R.Left+x;
  R.Bottom:=R.Bottom+y;
  R.Top:=R.Top+y;
end;

function DrawCopyright(Canvas:TCanvas; Copyright:string; pageRect:TRect; AFontHeight:Integer):integer;
var
  tR:TRect;
begin
  if AFontHeight>0 then AFontHeight:=-AFontHeight;
  Canvas.Font.Height:=AFontHeight - (AFontHeight div 4);
  Canvas.Font.Style:=[];
  Canvas.Font.Color:=clGray;
  tR.Left:=pageRect.Left;
  tR.Top:=pageRect.Bottom+1;
  tR.Right:=pageRect.Right;
  tR.Bottom:=pageRect.Bottom-Canvas.Font.Height+1;
  Canvas.TextRect2(tR, Copyright, [tfBottom, tfNoClip, tfNoPrefix, tfSingleLine, tfCenter]);
  Result:=pageRect.Bottom-trunc(abs(AFontHeight));
end;

function DrawCompetitionInfo(Canvas:TCanvas; DrawTitle, DrawType, DrawOtherInfo:string;
  Alignment:TAlignment; var pageRect:TRect; InfoFontHeight:Integer; InfoLineWidth:Integer; FontColor, LineColor, FillColor:TColor;
  RoundCorners:Integer; CalcOnly:Boolean):Integer;
var
  tmp:string;
  tR:TRect;
  tS:TSize;
  w,i:Integer;
begin
  Result:=pageRect.Top;
  // draw info texts
  if InfoFontHeight>0 then InfoFontHeight:=-InfoFontHeight;

  if DrawTitle+DrawType+DrawOtherInfo<>'' then
  begin
    Canvas.Pen.Width:=InfoLineWidth;
    Canvas.Pen.Color:=LineColor;
    Canvas.Brush.Style:=bsClear;

    tmp:=' '+DrawTitle+' ';
    Canvas.Font.Height:=InfoFontHeight*2;
    Canvas.Font.Style:=[fsBold];
    Canvas.Font.Color:=FontColor;
    ts.cy:=Canvas.TextHeight(tmp);
    tS.cy:=tS.cy+(tS.cy div 4);
    if (pageRect.Bottom-pageRect.Top)>(pageRect.Right-pageRect.Left) then
      tR:=Rect(pageRect.Left+((pageRect.Right-pageRect.Left) div 2),pageRect.Top,pageRect.Right,pageRect.Top+tS.cy)  // portrait
    else
      tR:=Rect(pageRect.Right-((pageRect.Bottom-pageRect.Top) div 2),pageRect.Top,pageRect.Right,pageRect.Top+tS.cy); // landscape
    if not CalcOnly then
      case Alignment of
        taCenter:
          begin
            w:=tR.Right-tR.Left;
            tR.Left:=pageRect.Left+((pageRect.Right-pageRect.Left-w) div 2);
            tR.Right:=tR.Left+w;
            Canvas.TextRect2(tR,tmp,[tfVerticalCenter,tfNoClip,tfNoPrefix,tfSingleLine,tfCenter,tfEndEllipsis]);
          end;
        taLeftJustify:
          begin
            _offsetRect(tR,pageRect.Left-tR.Left,0);
            Canvas.TextRect2(tR,tmp,[tfVerticalCenter,tfNoClip,tfNoPrefix,tfSingleLine,tfLeft,tfEndEllipsis]);
          end;
      else
        Canvas.TextRect2(tR,tmp,[tfVerticalCenter,tfNoClip,tfNoPrefix,tfSingleLine,tfRight,tfEndEllipsis]);
      end;

    tmp:='  '+DrawType+'  ';
    Canvas.Brush.Style:=bsSolid;
    Canvas.Brush.Color:=FillColor;
    Canvas.Font.Height:=round(InfoFontHeight*1.5);
    ts.cy:=Canvas.TextHeight(tmp);
    tS.cy:=tS.cy+(tS.cy div 4);
    tR:=Rect(tR.Left,tR.Bottom,tR.Right,tR.Bottom+tS.cy);
    if not CalcOnly then
    begin
      if RoundCorners=0 then
        Canvas.Rectangle2(tR)
      else
        Canvas.RoundRect(tR.Left,tR.Top,tR.Right,tR.Bottom,RoundCorners,RoundCorners);
    end;
    Canvas.Brush.Style:=bsClear;
    if not CalcOnly then
      case Alignment of
        taCenter:Canvas.TextRect2(tR,tmp,[tfVerticalCenter,tfNoClip,tfNoPrefix,tfSingleLine,tfCenter,tfEndEllipsis]);
        taLeftJustify:Canvas.TextRect2(tR,tmp,[tfVerticalCenter,tfNoClip,tfNoPrefix,tfSingleLine,tfRight,tfEndEllipsis]);
      else
        Canvas.TextRect2(tR,tmp,[tfVerticalCenter,tfNoClip,tfNoPrefix,tfSingleLine,tfLeft,tfEndEllipsis]);
      end;

    pageRect.Top:=tR.Bottom;

    tmp:=DrawOtherInfo;
    Canvas.Font.Height:=round(InfoFontHeight*1.4);
    _offsetRect(tR,0,(tR.Bottom-tR.Top)+(tR.Bottom-tR.Top) div 4);
    if not CalcOnly then
      case Alignment of
        taCenter:
          Canvas.TextRect2(tR,tmp,[tfTop,tfNoClip,tfNoPrefix,tfWordBreak,tfCenter]);
        taLeftJustify:
          begin
            tR.Left:=tR.Left-Canvas.TextWidth('  ');
            Canvas.TextRect2(tR,tmp,[tfTop,tfNoClip,tfNoPrefix,tfWordBreak,tfLeft]);
          end;
      else
        begin
          tR.Right:=tR.Right-Canvas.TextWidth('  ');
          Canvas.TextRect2(tR,tmp,[tfTop,tfNoClip,tfNoPrefix,tfWordBreak,tfRight]);
        end;
      end;
    w:=0;
    for i:=1 to length(tmp) do
      if tmp[i]=#13 then
        inc(w);
    Result:=pageRect.Top+round(Canvas.TextHeight('Mg')*1.66)*(w+1);
  end;

end;
